<?php
/**
 * @package Uniquetext
 */

/*
Plugin Name: UniqueText Plagiarism Checker
Plugin URI: https://covenantlinks.com/plagiarismchecker
Description: This Duplicate Checker tool is designed by Internet Marketer therefore it is suitable for webmaster/blogger and writing company who need to check uniqueness of articles on daily basis.
Version: 3.0
Author: CovenantLinks
License: GPLv2 or later
Text Domain: uniquetext
*/

function uqtx_admin_actions() {
     add_options_page("UniqueText Setting", "UniqueText Setting", 1, "uniquetext_setting", "uqtx_setting_admin");
     add_submenu_page( 'tools.php', 'Bulk Post Plagiarism Checking by UniqueText', 'UniqueText Bulk Post Checker', 1, 'uniquetext_bulk_checker', 'uqtx_bulk_checker');
}
add_action('admin_menu', 'uqtx_admin_actions');

function uqtx_bulk_checker(){
  $paged = isset($_GET['paged']) ? $_GET['paged'] : 1;
  $args = array(
  'post_type'=> array('post','page'),
  'orderby'    => 'ID',
  'post_status' => array('publish', 'pending', 'draft', 'future', 'private', 'inherit'),
  'order'    => 'DESC',
  'posts_per_page' => 30, // change to -1 to retrive all the post
  'paged' => $paged
  );

  $the_query = new WP_Query( $args );
   
  if ( $the_query->have_posts() ) : 
      $arr_posts=array();
   
      
      $param = [
          'query' => $the_query,
          'show_posts_links' => false
      ];
      $output = '<div id="btn_startbulk"><button onclick="startbulk()" style="margin:50px 0 0 0;color:white;background-color:#007cba;box-shadow:none;border:none;padding: 10px 15px;text-align: center;display: block;font-size: 16px;cursor:pointer">Start Checking</button></div>
        <ul style="width:800px;display:inline-block">';
      $output .= '<li style="margin-bottom:10px;display:inline-block;width:100%;">
        <div style="width:80%;float:left;font-size:20px;">Post Title</div>
        <div style="width:20%;float:left;text-align:center;font-size:20px;">Plagiarism Rate</div>
        </li>
        <li><a onclick="checkAll()" style="cursor:pointer">&gt;&gt;Check All&lt;&lt;</a></li>
        ';

      // the loop -->
      while ( $the_query->have_posts() ) : $the_query->the_post(); 
        $id = get_the_ID();
        $postmeta = get_post_meta($id,'uqtx_result',true);
        $uqtx_result = $postmeta;
        //$uqtx_result = unserialize($postmeta);
        $arr_posts[$id] = get_the_content();

        if($uqtx_result!= null){
          // print_r($uqtx_result);
          // print_r('<br><br>');
          if($uqtx_result['message']=='NO DUPLICATE FOUND'){$rate = 'unique';}
          else $rate = $uqtx_result['dup_rate'].'%';
        } else $rate = '-';
        $output .= '<li style="border-top: 1px solid black; padding: 9px 0 3px 0;display:inline-block;width:100%;">
        
        <div style="width:80%;float:left;"><input type="checkbox" style="margin-right:10px;" id="'.$id.'" onclick="ischeck('.$id.')"><a href="' . get_edit_post_link( $id ) . '">' 
        . get_the_title() . '</a></div>
        <div style="width:20%;float:left;text-align:center;" id="rate'. $id . '">'.$rate.'</div>
        </li>';

      endwhile; 
      // end of the loop -->
   
      // pagination here -->
      
      $paginate_links = 

        paginate_links( array(
            'base'         => str_replace( 999999999, '%#%', esc_url( get_pagenum_link( 999999999 ) ) ),
            'total'        => $the_query->max_num_pages,
            'current'      => max( 1, $paged ),
            'format'       => '?paged=%#%',
            'show_all'     => false,
            'type'         => 'plain',
            'end_size'     => 2,
            'mid_size'     => 1,
            'prev_next'    => true,
            'prev_text'    => sprintf( '<i></i> %1$s', __( '<', 'text-domain' ) ),
            'next_text'    => sprintf( '%1$s <i></i>', __( '>', 'text-domain' ) ),
            'add_args'     => false,
            'add_fragment' => '',
        ) );
      
      $output .= '</ul>';
      $output .= '<div class="pagination">'.$paginate_links.'</div>';
  
      echo '<h2 style="font-size:30px;">UniqueText Bulk Post Checker</h2>';
      echo 'Note:<br> UniqueText plugin will retrieve post content from database before checking. <br>So, if the content is populated using shortcode (ie. rapid composer), the result may not be accurate, <br>please use our web version instead.';
      echo $output;
      wp_reset_postdata(); 
      uqtx_bulk_script($arr_posts);

  endif;
}
    
    

function uqtx_bulk_script($arr_posts) {
 //script for click event button
    

  if ( ! wp_script_is( 'jquery', 'done' ) ) {
      wp_enqueue_script( 'jquery' );
    }

    $email = get_option('uqtx_email');
    $tokenapi = get_option('uqtx_token');
    $preloader = plugin_dir_url( __FILE__ ) . 'assets/img/Preloader_11.gif';
    $nonce = wp_create_nonce("uqtx_add_postmeta_nonce");
    //global $post;

    $scriptData = array(
        'email' => $email,
        'tokenapi' => $tokenapi,
        'preloader' => $preloader,
        'ajaxurl' => admin_url( 'admin-ajax.php' ),
        'posts' => $arr_posts,
        'nonce' => $nonce
        //'postmeta' => $post->post_author
        //'postmeta' => $uqtx_result
    );

    wp_enqueue_script( 'uqtx-js', plugin_dir_url( __FILE__ ) . 'assets/js/bulk.js', array( 'jquery' ), '', true );
    wp_localize_script('uqtx-js', 'uqtx_bulk', $scriptData);
    
    wp_register_style( 'uqtx-bulk-css', plugin_dir_url( __FILE__ ) . 'assets/css/uqtx-bulk.css' );
    wp_enqueue_style( 'uqtx-bulk-css' );
}


function uqtx_setting_admin() {
	//print_r($_POST['uqtx_nonce']);die();
    if(isset($_POST['uqtx_email'])&&isset($_POST['uqtx_token'])&&wp_verify_nonce($_POST['uqtx_nonce'], 'uqtx_update_option' )):
    	//print_r($_POST['uqtx_nonce']);die();
    	$email = $_POST['uqtx_email'];
    	if(is_email($email)){update_option('uqtx_email', sanitize_email($email));}
        update_option('uqtx_email', sanitize_email($email));
    	  update_option('uqtx_token', sanitize_text_field($_POST['uqtx_token']));
        echo '<div class="updated"><p><strong>Updated</strong>: Data has been updated successfully.</p></div>';
    endif;
    $uqtx_email = get_option('uqtx_email');
    $uqtx_token = get_option('uqtx_token');
?>
<div class="wrap">
    <?php    echo "<h2>" . __( 'UniqueText Plugin Setting', 'uqtx' ) . "</h2>"; ?>


    <p style="margin-top: 40px">You need to <a href="https://covenantlinks.com/id/uniquetext">register first</a>, in order to get API token needed to run UNIQUETEXT plagiarism checker.</p>
      
    <form name="uqtx_form" method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">
        <input type="hidden" name="uqtx_nonce" value="<?php echo wp_create_nonce( 'uqtx_update_option' ); ?>" />
        <p><?php _e("Registered Email: " ); ?><br><input type="text" name="uqtx_email" value="<?php echo $uqtx_email; ?>" size="50"><?php _e(" ex: covenantlinks@gmail.com" ); ?></p>
        <p><?php _e("API Token: " ); ?><br><input type="text" name="uqtx_token" value="<?php echo $uqtx_token; ?>" size="50"><?php _e(" Put your API here" ); ?></p>
        <p class="submit">
        <input type="submit" name="Submit" value="<?php _e('Save Configuration', 'uqtx_save_button' ) ?>" />
        </p>
    </form>
</div> 
<?php
}

//Add Custom Metabox
function uqtx_custom_metabox(){
 
    add_meta_box( 
                    'uqtx-metabox',
                    'UniqueText Plagiarism Checker',
                    'uqtx_custom_metabox_callback',
                    array('post', 'page', 'custom_post_type'),
                    'side',
                    'high'
                );
}
 
add_action('add_meta_boxes', 'uqtx_custom_metabox');
 
 
function uqtx_custom_metabox_callback(){
    global $post;
    $post_id = $post->ID; 

    $nonce = wp_create_nonce("uqtx_add_postmeta_nonce");
     
    ?>
 
    <div class="row" style="margin:15px 0;">
        <a name="unique-text-check">
        <button id="check-article" style="color:white;background-color:#007cba;box-shadow:none;border:none;padding: 10px 15px;text-align: center;display: inline-block;font-size: 16px;cursor:pointer" data-nonce="<?= $nonce; ?>" data-post_id="<?= $post_id; ?>">Check Article</button>
        </a>
        <img id="check-quota" src="<?php echo plugin_dir_url( __FILE__ ) .'/assets/img/limit.png' ?>" style="cursor: pointer;max-height:40px;display:inline-block;vertical-align:bottom;margin-left:10px;" title="check quota" />
        <img id="fix-punc" src="<?php echo plugin_dir_url( __FILE__ ) .'/assets/img/punctuation-fixer.png' ?>" style="cursor: pointer;max-height:40px;display:inline-block;vertical-align:bottom;margin-left:10px;" title="Fix most of punctuation placements and spaces" />

    </div>
    <div class="row">
    	
    	<p>Table will not be checked and will be removed from text. If your text contains table, please backup somewhere else before checking.</p>
    </div>
    <div class="row" id="result_uqtx" style="min-height:100px;display:none;padding:30px 0">
    	<div style="text-align: center"><img src="<?php echo plugin_dir_url( __FILE__ ) .'assets/img/Preloader_11.gif'; ?>" width="50px" /></div>
    </div>
 
    <?php
}

function add_postmeta(){
    //cara ngambil data yang dikirim ajax dengan $_REQUEST['key nya']

    if ( !wp_verify_nonce( $_REQUEST['nonce'], "uqtx_add_postmeta_nonce")) {
          exit("No naughty business please");
       }   

       $meta_uqtx_result = $_REQUEST['result'];
       

       //$statusUpd = update_post_meta($_REQUEST["post_id"], "uqtx_result", serialize($meta_uqtx_result));
       $statusUpd = update_post_meta($_REQUEST["post_id"], "uqtx_result", $meta_uqtx_result);

       if($statusUpd === false) {
          $result['type'] = "error";
       }
       else {
          $result['type'] = "success";
          $result['value'] = $meta_uqtx_result;
       }
       print_r($result);
       die();
}
add_action("wp_ajax_add_postmeta", "add_postmeta");

function uqtx_add_script() {
 //script for click event button
    

	if ( ! wp_script_is( 'jquery', 'done' ) ) {
     	wp_enqueue_script( 'jquery' );
   	}

   	$email = get_option('uqtx_email');
   	$tokenapi = get_option('uqtx_token');
   	$preloader = plugin_dir_url( __FILE__ ) . 'assets/img/Preloader_11.gif';
    $nonce = wp_create_nonce("uqtx_add_postmeta_nonce");
    
    global $post;
    $postmeta = get_post_meta($post->ID,'uqtx_result',true);
    // $postmeta = unserialize($postmeta);
    //$postmeta = base64_decode($postmeta);
    if($postmeta!=''){
      $uqtx_result = json_encode($postmeta);
    } else $uqtx_result = false;

   	$scriptData = array(
        'email' => $email,
        'tokenapi' => $tokenapi,
        'preloader' => $preloader,
        'ajaxurl' => admin_url( 'admin-ajax.php' ),
        'nonce' => $nonce,
        'postID'=> $post->ID,
        'postmeta' => $uqtx_result
    );

    wp_enqueue_script( 'uqtx-js', plugin_dir_url( __FILE__ ) . 'assets/js/custom.js', array( 'jquery' ), '', true );
    wp_localize_script('uqtx-js', 'uqtx_options', $scriptData);

    wp_register_style( 'uqtx-css', plugin_dir_url( __FILE__ ) . 'assets/css/uqtx.css' );
    wp_enqueue_style( 'uqtx-css' );

    
    
}
add_action( 'admin_print_scripts-post-new.php', 'uqtx_add_script', 11 );
add_action( 'admin_print_scripts-post.php', 'uqtx_add_script', 11 );


?>
